      double precision function map_steel_wnsolve 
     & (gbn,v,g,radius,vm,sv,time)
      implicit none                                     
      double precision gbn,v,g,radius,vm,sv,time
      double precision map_steel_wnsolve,map_steel_wkinetic
      double precision gb1,gb2,gb3,fac,limit,f1,f2,f3
      integer icount

* start by bracketing the solution

      icount=0

      gb1=0.4*gbn
      gb3=4.0*gbn
      fac=2.0

      if ((v .gt. 0.65) .or. (v .lt. 0.05)) then
           limit=0.025
      else
           limit=0.05
      endif

1     f1=map_steel_wkinetic(gb1,time,g,radius,vm,sv)-v
      f3=map_steel_wkinetic(gb3,time,g,radius,vm,sv)-v

      icount=icount+1
      if (icount .gt. 40 ) then
         write(6,*)' no bracketing in wnsolve'
      endif


      if (f3 .lt. 0.0) then
          gb3=gb3*fac
          goto 1
      endif
      if (f1 .gt. 0.0) then
          gb1=gb1/fac
          goto 1
      endif

2     gb2=0.5d0*(gb1+gb3)

      icount=icount+1
      if (icount .gt. 40 ) then
         write(6,*)' no solution in wnsolve'
      endif

      f2=map_steel_wkinetic(gb2,time,g,radius,vm,sv)-v
      if (dabs(f2/v) .le. limit) goto 3
      if (f3*f2 .lt. 0) then
          gb1=gb2
          f1=f2
          goto 2
      else
          f3=f2
          gb3=gb2
          goto 2
      endif

3     map_steel_wnsolve=gb2

      end
